/***************************************
*                                      *
*   Copyright (c) 2002 Jean-Eric Pin   *
*   All rights reserved.               *
*                                      *
*   TAB = 2 spaces                     *
*                                      *
***************************************/

/*-------------------------------------------------------------------
 * AOmega.c		Jean-Eric Pin 
 *-------------------------------------------------------------------
 */ 		

/*-------------------------------------------------------------------
 * Calcul de A^\omega pour un ensemble A d'lments
 *---------------------------------------------------------------------------*/ 		

#include <stdlib.h>
#include <stdio.h>
#include "Main.h"
#include "Calcul.h"
#include "DclassesIteratif.h"
#include "Globales.h"
#include "Memoire.h"
#include "Reduction.h"
#include "Sortie.h"
#include "SortieLaTeX.h"
#include "TableDeS.h"
#include "Utilitaires.h"
#include "AOmega.h"

extern unsigned long NbElements, NbIdempotents;
extern unsigned short NbLettres, PossedeUnNeutre;
extern unsigned long CalculsEffectues;
extern char **Messages;
extern info *Table; 		/* La table contenant les informations sur les lments */
extern info2 *Table2; 		/* La table contenant les autres informations sur les lments */
extern unsigned long **TableDeS;	/* La table de multiplication du semigroupe */

void CalculA2(unsigned long *TableA, unsigned long *TableA2)
{
	unsigned long s, t;
	
	for (s = 0; s < Taille; s++)
	{
		if (TableA[s].Statut & EST_DANS_T);
		for (t = 0; t < Taille; t++)
		{
			if (TableA[t].Statut & EST_DANS_T)
			{
				st = TableDeS[TableA[s]][TableA[t]]; 
				TableA2[st].Statut |= EST_DANS_T
			}
		}	
	}	
}

void CalculAOmega(unsigned long x, unsigned long y, unsigned long *TableT, unsigned long *Taille)
{
	unsigned long s, sx, sy, TailleCourante, NbGenerateursT;
	
/*	TableGenerateursT = AlloueMemoireTableau(NbElements); */
	
	TableT[0] = x;
	Table[x].Statut |= EST_DANS_T;
	TableT[1] = y;
	Table[y].Statut |= EST_DANS_T;
	
	NbGenerateursT = TailleCourante = 2;
	s = 0;
	while (s < TailleCourante)
	{
		sx = TableDeS[TableT[s]][x]; 
		if ((Table[sx].Statut & EST_DANS_T) == 0)		/* Si sx n'est pas dans T */
		{
			Table[sx].Statut |= EST_DANS_T;
			TableT[TailleCourante] = sx;
			TailleCourante++;
		}		
		sy = TableDeS[TableT[s]][y]; 
		if ((Table[sy].Statut & EST_DANS_T) == 0)		/* Si sy n'est pas dans T */
		{
			Table[sy].Statut |= EST_DANS_T;
			TableT[TailleCourante] = sy;
			TailleCourante++;
		}		
		s++;
	}
	*Taille = TailleCourante;
}

void SortieAOmega(unsigned long *TableT, unsigned long Taille)
{
	unsigned long u;
	
	printf("<x, y> = {");
	for (u = 0; u < Taille; u++)
	{
		SortieMot(TableT[u]);
		printf(", ");
	}	
	printf("\b\b}\n");
}


/*
	free(TableT);
	free(TableGenerateursT);
*/